// mainfrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

class CMainFrame : public CFrameWnd
{
protected: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
public:

// Operations
public:

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnNodeNewnode();
	afx_msg void OnNodeRemove();
	afx_msg void OnNodeDuplicate();
	afx_msg void OnNodeBringtofront();
	afx_msg void OnNodeSendtoback();
	afx_msg void OnUpdateNodeRemove(CCmdUI* pCmdUI);
	afx_msg void OnUpdateNodeBringtofront(CCmdUI* pCmdUI);
	afx_msg void OnUpdateNodeSendtoback(CCmdUI* pCmdUI);
	afx_msg void OnUpdateNodeDuplicate(CCmdUI* pCmdUI);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnPopupBgcolor();
	afx_msg void OnPopupFgcolor();
	afx_msg void OnPopupDeffillcolor();
	afx_msg void OnPopupItembordercolor();
	afx_msg void OnPopupItemfillcolor();
	afx_msg void OnPopupItemgraphic();
	afx_msg void OnPopupItemshape();
	afx_msg void OnPopupItemtextcolor();
	afx_msg void OnPopupFullgraphic();
	afx_msg void OnPopupHalfgraphic();
	afx_msg void OnPopupIcongraphic();
	afx_msg void OnPopupNographic();
	afx_msg void OnPopupFont();
	afx_msg void OnNodeFindnode();
	afx_msg void OnNodeFindagain();
	afx_msg void OnUpdateOptionsDrawarrows(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsDrawbacklinks(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsDrawcolored(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsDrawconnlabels(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsDrawhandles(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsDrawitemlabels(CCmdUI* pCmdUI);
	afx_msg void OnOptionsDrawarrows();
	afx_msg void OnOptionsDrawbacklinks();
	afx_msg void OnOptionsDrawcolored();
	afx_msg void OnOptionsDrawconnlabels();
	afx_msg void OnOptionsDrawhandles();
	afx_msg void OnOptionsDrawitemlabels();
	afx_msg void OnUpdateNodeFindagain(CCmdUI* pCmdUI);
	afx_msg void OnOptionsArrangemodeCompact();
	afx_msg void OnUpdateOptionsArrangemodeCompact(CCmdUI* pCmdUI);
	afx_msg void OnOptionsArrangemodeFlowchart();
	afx_msg void OnUpdateOptionsArrangemodeFlowchart(CCmdUI* pCmdUI);
	afx_msg void OnOptionsArrangemodeHierarchy();
	afx_msg void OnUpdateOptionsArrangemodeHierarchy(CCmdUI* pCmdUI);
	afx_msg void OnOptionsArrangemodeTree();
	afx_msg void OnUpdateOptionsArrangemodeTree(CCmdUI* pCmdUI);
	afx_msg void OnOptionsAutoarrangeAutomatic();
	afx_msg void OnOptionsAutoarrangeManual();
	afx_msg void OnOptionsAutoarrangeNow();
	afx_msg void OnUpdateOptionsAutoarrangeAutomatic(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsAutoarrangeManual(CCmdUI* pCmdUI);
	afx_msg void OnOptionsDrawdirBottomtotop();
	afx_msg void OnOptionsDrawdirLefttoright();
	afx_msg void OnOptionsDrawdirRighttoleft();
	afx_msg void OnOptionsDrawdirToptobottom();
	afx_msg void OnUpdateOptionsDrawdirBottomtotop(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsDrawdirLefttoright(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsDrawdirRighttoleft(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsDrawdirToptobottom(CCmdUI* pCmdUI);
	afx_msg void OnOptionsDrawscale100();
	afx_msg void OnOptionsDrawscale200();
	afx_msg void OnOptionsDrawscale25();
	afx_msg void OnOptionsDrawscale400();
	afx_msg void OnOptionsDrawscale50();
	afx_msg void OnOptionsDrawscale75();
	afx_msg void OnOptionsDrawscaleFittoscreen();
	afx_msg void OnUpdateOptionsDrawscale100(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsDrawscale200(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsDrawscale25(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsDrawscale400(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsDrawscale50(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsDrawscale75(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsDrawscaleFittoscreen(CCmdUI* pCmdUI);
	afx_msg void OnOptionsRubberbandBoth();
	afx_msg void OnOptionsRubberbandHandles();
	afx_msg void OnOptionsRubberbandItems();
	afx_msg void OnOptionsRubberbandNone();
	afx_msg void OnUpdateOptionsRubberbandBoth(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsRubberbandHandles(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsRubberbandItems(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsRubberbandNone(CCmdUI* pCmdUI);
	afx_msg void OnSpecialRandomsizednodes();
	afx_msg void OnUpdateSpecialRandomsizednodes(CCmdUI* pCmdUI);
	afx_msg void OnSpecialRandomtree15nodes();
	afx_msg void OnSpecialRandomtree25nodes();
	afx_msg void OnSpecialRandomtree50nodes();
	afx_msg void OnSpecialRandomtree8nodes();
	afx_msg void OnSpecialRandomdirectedgraph15nodes();
	afx_msg void OnSpecialRandomdirectedgraph25nodes();
	afx_msg void OnSpecialRandomdirectedgraph50nodes();
	afx_msg void OnSpecialRandomdirectedgraph8nodes();
	afx_msg void OnUpdateFilePrintout(CCmdUI* pCmdUI);
	afx_msg void OnFilePrintout();
	//}}AFX_MSG
	afx_msg LRESULT OnFindReplace(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
