// mainfrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "itgdemo.h"

#include "mainfrm.h"

#include "itgdmdoc.h"
#include "itgdmvw.h"

#include "itgdefs.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

static UINT NEAR WM_FINDREPLACE = ::RegisterWindowMessage(FINDMSGSTRING);

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_NODE_NEWNODE, OnNodeNewnode)
	ON_COMMAND(ID_NODE_REMOVE, OnNodeRemove)
	ON_COMMAND(ID_NODE_DUPLICATE, OnNodeDuplicate)
	ON_COMMAND(ID_NODE_BRINGTOFRONT, OnNodeBringtofront)
	ON_COMMAND(ID_NODE_SENDTOBACK, OnNodeSendtoback)
	ON_UPDATE_COMMAND_UI(ID_NODE_REMOVE, OnUpdateNodeRemove)
	ON_UPDATE_COMMAND_UI(ID_NODE_BRINGTOFRONT, OnUpdateNodeBringtofront)
	ON_UPDATE_COMMAND_UI(ID_NODE_SENDTOBACK, OnUpdateNodeSendtoback)
	ON_UPDATE_COMMAND_UI(ID_NODE_DUPLICATE, OnUpdateNodeDuplicate)
	ON_WM_RBUTTONDOWN()
	ON_COMMAND(ID_POPUP_BGCOLOR, OnPopupBgcolor)
	ON_COMMAND(ID_POPUP_FGCOLOR, OnPopupFgcolor)
	ON_COMMAND(ID_POPUP_DEFFILLCOLOR, OnPopupDeffillcolor)
	ON_COMMAND(ID_POPUP_ITEMBORDERCOLOR, OnPopupItembordercolor)
	ON_COMMAND(ID_POPUP_ITEMFILLCOLOR, OnPopupItemfillcolor)
	ON_COMMAND(ID_POPUP_ITEMGRAPHIC, OnPopupItemgraphic)
	ON_COMMAND(ID_POPUP_ITEMSHAPE, OnPopupItemshape)
	ON_COMMAND(ID_POPUP_ITEMTEXTCOLOR, OnPopupItemtextcolor)
	ON_COMMAND(ID_POPUP_FULLGRAPHIC, OnPopupFullgraphic)
	ON_COMMAND(ID_POPUP_HALFGRAPHIC, OnPopupHalfgraphic)
	ON_COMMAND(ID_POPUP_ICONGRAPHIC, OnPopupIcongraphic)
	ON_COMMAND(ID_POPUP_NOGRAPHIC, OnPopupNographic)
	ON_COMMAND(ID_POPUP_FONT, OnPopupFont)
	ON_COMMAND(ID_NODE_FINDNODE, OnNodeFindnode)
	ON_COMMAND(ID_NODE_FINDAGAIN, OnNodeFindagain)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWARROWS, OnUpdateOptionsDrawarrows)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWBACKLINKS, OnUpdateOptionsDrawbacklinks)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWCOLORED, OnUpdateOptionsDrawcolored)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWCONNLABELS, OnUpdateOptionsDrawconnlabels)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWHANDLES, OnUpdateOptionsDrawhandles)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWITEMLABELS, OnUpdateOptionsDrawitemlabels)
	ON_COMMAND(ID_OPTIONS_DRAWARROWS, OnOptionsDrawarrows)
	ON_COMMAND(ID_OPTIONS_DRAWBACKLINKS, OnOptionsDrawbacklinks)
	ON_COMMAND(ID_OPTIONS_DRAWCOLORED, OnOptionsDrawcolored)
	ON_COMMAND(ID_OPTIONS_DRAWCONNLABELS, OnOptionsDrawconnlabels)
	ON_COMMAND(ID_OPTIONS_DRAWHANDLES, OnOptionsDrawhandles)
	ON_COMMAND(ID_OPTIONS_DRAWITEMLABELS, OnOptionsDrawitemlabels)
	ON_UPDATE_COMMAND_UI(ID_NODE_FINDAGAIN, OnUpdateNodeFindagain)
	ON_COMMAND(ID_OPTIONS_ARRANGEMODE_COMPACT, OnOptionsArrangemodeCompact)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_ARRANGEMODE_COMPACT, OnUpdateOptionsArrangemodeCompact)
	ON_COMMAND(ID_OPTIONS_ARRANGEMODE_FLOWCHART, OnOptionsArrangemodeFlowchart)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_ARRANGEMODE_FLOWCHART, OnUpdateOptionsArrangemodeFlowchart)
	ON_COMMAND(ID_OPTIONS_ARRANGEMODE_HIERARCHY, OnOptionsArrangemodeHierarchy)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_ARRANGEMODE_HIERARCHY, OnUpdateOptionsArrangemodeHierarchy)
	ON_COMMAND(ID_OPTIONS_ARRANGEMODE_TREE, OnOptionsArrangemodeTree)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_ARRANGEMODE_TREE, OnUpdateOptionsArrangemodeTree)
	ON_COMMAND(ID_OPTIONS_AUTOARRANGE_AUTOMATIC, OnOptionsAutoarrangeAutomatic)
	ON_COMMAND(ID_OPTIONS_AUTOARRANGE_MANUAL, OnOptionsAutoarrangeManual)
	ON_COMMAND(ID_OPTIONS_AUTOARRANGE_NOW, OnOptionsAutoarrangeNow)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_AUTOARRANGE_AUTOMATIC, OnUpdateOptionsAutoarrangeAutomatic)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_AUTOARRANGE_MANUAL, OnUpdateOptionsAutoarrangeManual)
	ON_COMMAND(ID_OPTIONS_DRAWDIR_BOTTOMTOTOP, OnOptionsDrawdirBottomtotop)
	ON_COMMAND(ID_OPTIONS_DRAWDIR_LEFTTORIGHT, OnOptionsDrawdirLefttoright)
	ON_COMMAND(ID_OPTIONS_DRAWDIR_RIGHTTOLEFT, OnOptionsDrawdirRighttoleft)
	ON_COMMAND(ID_OPTIONS_DRAWDIR_TOPTOBOTTOM, OnOptionsDrawdirToptobottom)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWDIR_BOTTOMTOTOP, OnUpdateOptionsDrawdirBottomtotop)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWDIR_LEFTTORIGHT, OnUpdateOptionsDrawdirLefttoright)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWDIR_RIGHTTOLEFT, OnUpdateOptionsDrawdirRighttoleft)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWDIR_TOPTOBOTTOM, OnUpdateOptionsDrawdirToptobottom)
	ON_COMMAND(ID_OPTIONS_DRAWSCALE_100, OnOptionsDrawscale100)
	ON_COMMAND(ID_OPTIONS_DRAWSCALE_200, OnOptionsDrawscale200)
	ON_COMMAND(ID_OPTIONS_DRAWSCALE_25, OnOptionsDrawscale25)
	ON_COMMAND(ID_OPTIONS_DRAWSCALE_400, OnOptionsDrawscale400)
	ON_COMMAND(ID_OPTIONS_DRAWSCALE_50, OnOptionsDrawscale50)
	ON_COMMAND(ID_OPTIONS_DRAWSCALE_75, OnOptionsDrawscale75)
	ON_COMMAND(ID_OPTIONS_DRAWSCALE_FITTOSCREEN, OnOptionsDrawscaleFittoscreen)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWSCALE_100, OnUpdateOptionsDrawscale100)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWSCALE_200, OnUpdateOptionsDrawscale200)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWSCALE_25, OnUpdateOptionsDrawscale25)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWSCALE_400, OnUpdateOptionsDrawscale400)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWSCALE_50, OnUpdateOptionsDrawscale50)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWSCALE_75, OnUpdateOptionsDrawscale75)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_DRAWSCALE_FITTOSCREEN, OnUpdateOptionsDrawscaleFittoscreen)
	ON_COMMAND(ID_OPTIONS_RUBBERBAND_BOTH, OnOptionsRubberbandBoth)
	ON_COMMAND(ID_OPTIONS_RUBBERBAND_HANDLES, OnOptionsRubberbandHandles)
	ON_COMMAND(ID_OPTIONS_RUBBERBAND_ITEMS, OnOptionsRubberbandItems)
	ON_COMMAND(ID_OPTIONS_RUBBERBAND_NONE, OnOptionsRubberbandNone)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_RUBBERBAND_BOTH, OnUpdateOptionsRubberbandBoth)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_RUBBERBAND_HANDLES, OnUpdateOptionsRubberbandHandles)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_RUBBERBAND_ITEMS, OnUpdateOptionsRubberbandItems)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_RUBBERBAND_NONE, OnUpdateOptionsRubberbandNone)
	ON_COMMAND(ID_SPECIAL_RANDOMSIZEDNODES, OnSpecialRandomsizednodes)
	ON_UPDATE_COMMAND_UI(ID_SPECIAL_RANDOMSIZEDNODES, OnUpdateSpecialRandomsizednodes)
	ON_COMMAND(ID_SPECIAL_RANDOMTREE_15NODES, OnSpecialRandomtree15nodes)
	ON_COMMAND(ID_SPECIAL_RANDOMTREE_25NODES, OnSpecialRandomtree25nodes)
	ON_COMMAND(ID_SPECIAL_RANDOMTREE_50NODES, OnSpecialRandomtree50nodes)
	ON_COMMAND(ID_SPECIAL_RANDOMTREE_8NODES, OnSpecialRandomtree8nodes)
	ON_COMMAND(ID_SPECIAL_RANDOMDIRECTEDGRAPH_15NODES, OnSpecialRandomdirectedgraph15nodes)
	ON_COMMAND(ID_SPECIAL_RANDOMDIRECTEDGRAPH_25NODES, OnSpecialRandomdirectedgraph25nodes)
	ON_COMMAND(ID_SPECIAL_RANDOMDIRECTEDGRAPH_50NODES, OnSpecialRandomdirectedgraph50nodes)
	ON_COMMAND(ID_SPECIAL_RANDOMDIRECTEDGRAPH_8NODES, OnSpecialRandomdirectedgraph8nodes)
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINTOUT, OnUpdateFilePrintout)
	ON_COMMAND(ID_FILE_PRINTOUT, OnFilePrintout)
	//}}AFX_MSG_MAP
	ON_REGISTERED_MESSAGE(WM_FINDREPLACE, OnFindReplace)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// arrays of IDs used to initialize control bars

// toolbar buttons - IDs are command buttons
static UINT BASED_CODE buttons[] =
{
	// same order as in the bitmap 'toolbar.bmp'
	ID_FILE_NEW,
	ID_FILE_OPEN,
	ID_FILE_SAVE,
		ID_SEPARATOR,
	ID_EDIT_CUT,
	ID_EDIT_COPY,
	ID_EDIT_PASTE,
		ID_SEPARATOR,
	ID_FILE_PRINT,
	ID_APP_ABOUT,
};

static UINT BASED_CODE indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadBitmap(IDR_MAINFRAME) ||
		!m_wndToolBar.SetButtons(buttons,
		  sizeof(buttons)/sizeof(UINT)))
	{
		TRACE("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE("Failed to create status bar\n");
		return -1;      // fail to create
	}

	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnNodeNewnode()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->AddItem("", -1);
	pITG->SetNumProperty("SelectedIndex", pITG->GetNumProperty("NewIndex"));
}

void CMainFrame::OnNodeRemove()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->RemoveItem(pITG->GetNumProperty("SelectedIndex"));
}

void CMainFrame::OnNodeDuplicate()
{
	int srcIx, cpyIx;
	
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	srcIx = (int)pITG->GetNumProperty("SelectedIndex");
	
	pITG->AddItem(pITG->GetStrProperty("List", srcIx), -1);
	cpyIx = (int)pITG->GetNumProperty("NewIndex");
	
	pITG->SetNumProperty("ItemXpos", pITG->GetNumProperty("ItemXpos", srcIx) + 10, cpyIx);	
	pITG->SetNumProperty("ItemYpos", pITG->GetNumProperty("ItemYpos", srcIx) + 10, cpyIx);
	pITG->SetNumProperty("ItemWidth", pITG->GetNumProperty("ItemWidth", srcIx), cpyIx);
	pITG->SetNumProperty("ItemHeight", pITG->GetNumProperty("ItemHeight", srcIx), cpyIx);	
	pITG->SetNumProperty("ItemBorderColor", pITG->GetNumProperty("ItemBorderColor", srcIx), cpyIx);
	pITG->SetNumProperty("ItemData", pITG->GetNumProperty("ItemData", srcIx), cpyIx);
	pITG->SetNumProperty("ItemDrawLabel", pITG->GetNumProperty("ItemDrawLabel", srcIx), cpyIx);
	pITG->SetNumProperty("ItemFillColor", pITG->GetNumProperty("ItemFillColor", srcIx), cpyIx);
	pITG->SetNumProperty("ItemGraphic", pITG->GetNumProperty("ItemGraphic", srcIx), cpyIx);
	pITG->SetNumProperty("ItemGraphicAlign", pITG->GetNumProperty("ItemGraphicAlign", srcIx), cpyIx);
	pITG->SetNumProperty("ItemGraphicHeight", pITG->GetNumProperty("ItemGraphicHeight", srcIx), cpyIx);
	pITG->SetNumProperty("ItemGraphicLeft", pITG->GetNumProperty("ItemGraphicLeft", srcIx), cpyIx);
	pITG->SetNumProperty("ItemGraphicStyle", pITG->GetNumProperty("ItemGraphicStyle", srcIx), cpyIx);
	pITG->SetNumProperty("ItemGraphicTop", pITG->GetNumProperty("ItemGraphicTop", srcIx), cpyIx);
	pITG->SetNumProperty("ItemGraphicWidth", pITG->GetNumProperty("ItemGraphicWidth", srcIx), cpyIx);
	pITG->SetNumProperty("ItemLabelAlign", pITG->GetNumProperty("ItemLabelAlign", srcIx), cpyIx);
	pITG->SetNumProperty("ItemLabelHeight", pITG->GetNumProperty("ItemLabelHeight", srcIx), cpyIx);
	pITG->SetNumProperty("ItemLabelLeft", pITG->GetNumProperty("ItemLabelLeft", srcIx), cpyIx);
	pITG->SetNumProperty("ItemLabelTop", pITG->GetNumProperty("ItemLabelTop", srcIx), cpyIx);
	pITG->SetNumProperty("ItemLabelWidth", pITG->GetNumProperty("ItemLabelWidth", srcIx), cpyIx);
	pITG->SetNumProperty("ItemShape", pITG->GetNumProperty("ItemShape", srcIx), cpyIx);
	pITG->SetNumProperty("ItemTextColor", pITG->GetNumProperty("ItemTextColor", srcIx), cpyIx);
	pITG->SetNumProperty("SelectedIndex", cpyIx);
}

void CMainFrame::OnNodeBringtofront()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int nIndex = (int)pITG->GetNumProperty("SelectedIndex");
	pITG->SetNumProperty("ItemIndex", pITG->GetNumProperty("ListCount") - 1, nIndex);
}

void CMainFrame::OnNodeSendtoback()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int nIndex = (int)pITG->GetNumProperty("SelectedIndex");
	pITG->SetNumProperty("ItemIndex", 0, nIndex);
}

void CMainFrame::OnUpdateNodeRemove(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSelected = pITG->GetNumProperty("SelectedIndex") != -1;
	pCmdUI->Enable(isSelected ? MF_GRAYED : MF_ENABLED);	
}

void CMainFrame::OnUpdateNodeBringtofront(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSelected = pITG->GetNumProperty("SelectedIndex") != -1;
	pCmdUI->Enable(isSelected ? MF_GRAYED : MF_ENABLED);	
}

void CMainFrame::OnUpdateNodeSendtoback(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSelected = pITG->GetNumProperty("SelectedIndex") != -1;
	pCmdUI->Enable(isSelected ? MF_GRAYED : MF_ENABLED);	
}

void CMainFrame::OnUpdateNodeDuplicate(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSelected = pITG->GetNumProperty("SelectedIndex") != -1;
	pCmdUI->Enable(isSelected ? MF_GRAYED : MF_ENABLED);	
}

void CMainFrame::OnRButtonDown(UINT nFlags, CPoint point)
{
	CFrameWnd::OnRButtonDown(nFlags, point);
}

void CMainFrame::OnPopupBgcolor()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	CColorDialog dlgColor;
	dlgColor.m_cc.rgbResult = pITG->GetNumProperty("BackColor");
	dlgColor.m_cc.Flags = CC_ENABLEHOOK + CC_RGBINIT;
	if(dlgColor.DoModal() == IDOK) {
		pITG->SetNumProperty("BackColor", dlgColor.GetColor());
	}
}

void CMainFrame::OnPopupFgcolor()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	CColorDialog dlgColor;
	dlgColor.m_cc.rgbResult = pITG->GetNumProperty("ForeColor");
	dlgColor.m_cc.Flags = CC_ENABLEHOOK + CC_RGBINIT;
	if(dlgColor.DoModal() == IDOK) {
		pITG->SetNumProperty("ForeColor", dlgColor.GetColor());
	}
}

void CMainFrame::OnPopupDeffillcolor()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	CColorDialog dlgColor;
	dlgColor.m_cc.rgbResult = pITG->GetNumProperty("FillColor");
	dlgColor.m_cc.Flags = CC_ENABLEHOOK + CC_RGBINIT;
	if(dlgColor.DoModal() == IDOK) {
		pITG->SetNumProperty("FillColor", dlgColor.GetColor());
	}
}

void CMainFrame::OnPopupItembordercolor()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int nIndex = (int)pITG->GetNumProperty("SelectedIndex");
	CColorDialog dlgColor;
	dlgColor.m_cc.rgbResult = pITG->GetNumProperty("ItemBorderColor", nIndex);
	dlgColor.m_cc.Flags = CC_ENABLEHOOK + CC_RGBINIT;
	if(dlgColor.DoModal() == IDOK) {
		pITG->SetNumProperty("ItemBorderColor", dlgColor.GetColor(), nIndex);
	}
}

void CMainFrame::OnPopupItemfillcolor()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int nIndex = (int)pITG->GetNumProperty("SelectedIndex");
	CColorDialog dlgColor;
	dlgColor.m_cc.rgbResult = pITG->GetNumProperty("ItemFillColor", nIndex);
	dlgColor.m_cc.Flags = CC_ENABLEHOOK + CC_RGBINIT;
	if(dlgColor.DoModal() == IDOK) {
		pITG->SetNumProperty("ItemFillColor", dlgColor.GetColor(), nIndex);
	}
}

void CMainFrame::OnPopupItemgraphic()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int nIndex = (int)pITG->GetNumProperty("SelectedIndex");
	int nGraphic;	
	nGraphic = (int)pITG->GetNumProperty("ItemGraphic", nIndex);
	pITG->SetNumProperty("GraphicSelect", nGraphic);
	nGraphic = (int)pITG->GetNumProperty("GraphicSelect");
	if(nGraphic != -1)
		pITG->SetNumProperty("ItemGraphic", nGraphic, nIndex);
}

void CMainFrame::OnPopupItemshape()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int nIndex = (int)pITG->GetNumProperty("SelectedIndex");
	int nShape;	
	nShape = (int)pITG->GetNumProperty("ItemShape", nIndex);
	pITG->SetNumProperty("ShapeSelect", nShape);
	nShape = (int)pITG->GetNumProperty("ShapeSelect");
	if(nShape != -1)
		pITG->SetNumProperty("ItemShape", nShape, nIndex);
}

void CMainFrame::OnPopupItemtextcolor()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int nIndex = (int)pITG->GetNumProperty("SelectedIndex");
	CColorDialog dlgColor;
	dlgColor.m_cc.rgbResult = pITG->GetNumProperty("ItemTextColor", nIndex);
	dlgColor.m_cc.Flags = CC_ENABLEHOOK + CC_RGBINIT;
	if(dlgColor.DoModal() == IDOK) {
		pITG->SetNumProperty("ItemTextColor", dlgColor.GetColor(), nIndex);
	}
}

void CMainFrame::OnPopupFullgraphic()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int nIndex = (int)pITG->GetNumProperty("SelectedIndex");
	pITG->SetNumProperty("ItemGraphicStyle", ITG_GraphicShapeFill, nIndex);
	pITG->SetNumProperty("ItemLabelLeft", 0, nIndex);
	pITG->SetNumProperty("ItemLabelWidth", 0, nIndex);
	pITG->SetNumProperty("ItemLabelTop", 0, nIndex);
	pITG->SetNumProperty("ItemLabelHeight", 0, nIndex);
	pITG->SetNumProperty("ItemLabelAlign", ITG_AlignMiddleCenter, nIndex);
}

void CMainFrame::OnPopupHalfgraphic()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int nIndex = (int)pITG->GetNumProperty("SelectedIndex");
	
	pITG->SetNumProperty("ItemGraphicStyle", ITG_GraphicIconFill, nIndex);
	pITG->SetNumProperty("ItemGraphicLeft", 0, nIndex);
	pITG->SetNumProperty("ItemGraphicWidth", pITG->GetNumProperty("ItemWidth", nIndex) / 2, nIndex);
	pITG->SetNumProperty("ItemGraphicTop", 0, nIndex);
	pITG->SetNumProperty("ItemGraphicHeight", pITG->GetNumProperty("ItemHeight", nIndex), nIndex);
	
	pITG->SetNumProperty("ItemLabelLeft", pITG->GetNumProperty("ItemWidth", nIndex)/2 + 2, nIndex);
	pITG->SetNumProperty("ItemLabelWidth", 0, nIndex);
	pITG->SetNumProperty("ItemLabelTop", 0, nIndex);
	pITG->SetNumProperty("ItemLabelHeight", 0, nIndex);
	pITG->SetNumProperty("ItemLabelAlign", ITG_AlignMiddleLeft, nIndex);
}

void CMainFrame::OnPopupIcongraphic()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int nIndex = (int)pITG->GetNumProperty("SelectedIndex");

	
	pITG->SetNumProperty("ItemGraphicStyle", ITG_GraphicIconFillIso, nIndex);
	pITG->SetNumProperty("ItemGraphicLeft", 5, nIndex);
	pITG->SetNumProperty("ItemGraphicWidth", 32, nIndex);
	pITG->SetNumProperty("ItemGraphicTop", 5, nIndex);
	pITG->SetNumProperty("ItemGraphicHeight", 32, nIndex);
	
	pITG->SetNumProperty("ItemLabelLeft", 40, nIndex);
	pITG->SetNumProperty("ItemLabelWidth", 0, nIndex);
	pITG->SetNumProperty("ItemLabelTop", 0, nIndex);
	pITG->SetNumProperty("ItemLabelHeight", 0, nIndex);
	pITG->SetNumProperty("ItemLabelAlign", ITG_AlignMiddleLeft, nIndex);
}

void CMainFrame::OnPopupNographic()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int nIndex = (int)pITG->GetNumProperty("SelectedIndex");
	pITG->SetNumProperty("ItemGraphicStyle", ITG_GraphicNone, nIndex);
	pITG->SetNumProperty("ItemLabelLeft", 0, nIndex);
	pITG->SetNumProperty("ItemLabelWidth", 0, nIndex);
	pITG->SetNumProperty("ItemLabelTop", 0, nIndex);
	pITG->SetNumProperty("ItemLabelHeight", 0, nIndex);
	pITG->SetNumProperty("ItemLabelAlign", ITG_AlignMiddleCenter, nIndex);
}

void CMainFrame::OnPopupFont()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	
	LOGFONT lfData;
	memset(&lfData, 0, sizeof(LOGFONT));
	lfData.lfHeight = (int)(pITG->GetFloatProperty("FontSize") / 0.6);
	lfData.lfWeight = (int)pITG->GetNumProperty("FontBold") ? FW_BOLD : FW_NORMAL;
	lfData.lfItalic = (int)pITG->GetNumProperty("FontItalic");
	lfData.lfUnderline = (int)pITG->GetNumProperty("FontUnderline");
	lfData.lfStrikeOut = (int)pITG->GetNumProperty("FontStrikethru");
	sprintf(lfData.lfFaceName, "%s", (const char *)pITG->GetStrProperty("FontName"));
	
	CFontDialog dlgFont;
	dlgFont.m_cf.lpLogFont = &lfData;
	dlgFont.m_cf.rgbColors = (COLORREF)pITG->GetNumProperty("ForeColor");
	dlgFont.m_cf.Flags |= CF_INITTOLOGFONTSTRUCT | CF_ENABLEHOOK | CF_EFFECTS;
	if(dlgFont.DoModal() == IDOK) {
		pITG->SetStrProperty("FontName", dlgFont.GetFaceName());
		pITG->SetFloatProperty("FontSize", (float)dlgFont.GetSize() / (float)10);
		pITG->SetNumProperty("FontBold", dlgFont.GetWeight() > FW_NORMAL);
		pITG->SetNumProperty("FontItalic", dlgFont.IsItalic());
		pITG->SetNumProperty("FontUnderline", dlgFont.m_cf.lpLogFont->lfUnderline);
		pITG->SetNumProperty("FontStrikethru", dlgFont.IsStrikeOut());
		pITG->SetNumProperty("ForeColor", (LONG)dlgFont.GetColor());
	}
}

void CMainFrame::OnNodeFindnode()
{	
	CFindReplaceDialog *pDlgFind = new CFindReplaceDialog();
	pDlgFind->m_fr.Flags |= FR_HIDEMATCHCASE | FR_HIDEWHOLEWORD | FR_HIDEUPDOWN;
	CItgDemoView *pView = (CItgDemoView *)GetActiveView();	
	pDlgFind->Create(TRUE, pView->m_sFindStr);
}

void CMainFrame::OnNodeFindagain()
{
	CItgDemoView *pView = (CItgDemoView *)GetActiveView();
	pView->FindNode(pView, pView->m_sFindStr);
}

LRESULT CMainFrame::OnFindReplace(WPARAM wParam, LPARAM lParam)
{
	CFindReplaceDialog *pDlgFind = CFindReplaceDialog::GetNotifier(lParam);
	if(pDlgFind->FindNext()) {
		CItgDemoView *pView = (CItgDemoView *)GetActiveView();
		pView->m_sFindStr = pDlgFind->GetFindString();
		pView->FindNode(pDlgFind, pView->m_sFindStr);
	}
	return 0L;
}
void CMainFrame::OnUpdateOptionsDrawarrows(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("DrawArrows") != 0;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnUpdateOptionsDrawbacklinks(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("DrawBackLinks") != 0;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnUpdateOptionsDrawcolored(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("DrawColored") != 0;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnUpdateOptionsDrawconnlabels(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("DrawConnLabels") != 0;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnUpdateOptionsDrawhandles(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("DrawHandles") != 0;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
	
}

void CMainFrame::OnUpdateOptionsDrawitemlabels(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("DrawItemLabels") != 0;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnOptionsDrawarrows()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("DrawArrows", !pITG->GetNumProperty("DrawArrows"));
}

void CMainFrame::OnOptionsDrawbacklinks()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("DrawArrows", 
		(pITG->GetNumProperty("DrawArrows") == ITG_NoBackLinks) ? ITG_SolidBackLinks : ITG_NoBackLinks);
}

void CMainFrame::OnOptionsDrawcolored()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("DrawColored", !pITG->GetNumProperty("DrawColored"));
}

void CMainFrame::OnOptionsDrawconnlabels()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("DrawConnLabels", !pITG->GetNumProperty("DrawConnLabels"));
}

void CMainFrame::OnOptionsDrawhandles()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("DrawHandles", !pITG->GetNumProperty("DrawHandles"));
}

void CMainFrame::OnOptionsDrawitemlabels()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("DrawItemLabels", !pITG->GetNumProperty("DrawItemLabels"));
}

void CMainFrame::OnUpdateNodeFindagain(CCmdUI* pCmdUI)
{
	CItgDemoView *pView = (CItgDemoView *)GetActiveView();
	pCmdUI->Enable((pView->m_sFindStr != "") ? MF_GRAYED : MF_ENABLED);	
}

void CMainFrame::OnOptionsArrangemodeCompact()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("ArrangeMode", ITG_ModeCompact);
}

void CMainFrame::OnUpdateOptionsArrangemodeCompact(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("ArrangeMode") == ITG_ModeCompact;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnOptionsArrangemodeFlowchart()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("ArrangeMode", ITG_ModeFlowChart);
}

void CMainFrame::OnUpdateOptionsArrangemodeFlowchart(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("ArrangeMode") == ITG_ModeFlowChart;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnOptionsArrangemodeHierarchy()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("ArrangeMode", ITG_ModeHierarchy);
}

void CMainFrame::OnUpdateOptionsArrangemodeHierarchy(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("ArrangeMode") == ITG_ModeHierarchy;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnOptionsArrangemodeTree()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("ArrangeMode", ITG_ModeTree);
}

void CMainFrame::OnUpdateOptionsArrangemodeTree(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("ArrangeMode") == ITG_ModeTree;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnOptionsAutoarrangeAutomatic()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("AutoArrange", ITG_AutoArrange);
}

void CMainFrame::OnOptionsAutoarrangeManual()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("AutoArrange", ITG_ManualArrange);
}

void CMainFrame::OnOptionsAutoarrangeNow()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("AutoArrange", ITG_ArrangeNow);
}

void CMainFrame::OnUpdateOptionsAutoarrangeAutomatic(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("AutoArrange") == ITG_AutoArrange;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnUpdateOptionsAutoarrangeManual(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("AutoArrange") == ITG_ManualArrange;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnOptionsDrawdirBottomtotop()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("DrawDir", ITG_BottomToTop);
}

void CMainFrame::OnOptionsDrawdirLefttoright()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("DrawDir", ITG_LeftToRight);
}

void CMainFrame::OnOptionsDrawdirRighttoleft()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("DrawDir", ITG_RightToLeft);
}

void CMainFrame::OnOptionsDrawdirToptobottom()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("DrawDir", ITG_TopToBottom);
}

void CMainFrame::OnUpdateOptionsDrawdirBottomtotop(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("DrawDir") == ITG_BottomToTop;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnUpdateOptionsDrawdirLefttoright(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("DrawDir") == ITG_LeftToRight;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnUpdateOptionsDrawdirRighttoleft(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("DrawDir") == ITG_RightToLeft;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnUpdateOptionsDrawdirToptobottom(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("DrawDir") == ITG_TopToBottom;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnOptionsDrawscale100()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("DrawScale", 100);
}

void CMainFrame::OnOptionsDrawscale200()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("DrawScale", 200);
}

void CMainFrame::OnOptionsDrawscale25()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("DrawScale", 25);
}

void CMainFrame::OnOptionsDrawscale400()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("DrawScale", 400);
}

void CMainFrame::OnOptionsDrawscale50()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("DrawScale", 50);
}

void CMainFrame::OnOptionsDrawscale75()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("DrawScale", 75);
}

void CMainFrame::OnOptionsDrawscaleFittoscreen()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("DrawScale", 0);
}

void CMainFrame::OnUpdateOptionsDrawscale100(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("DrawScale") == 100;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnUpdateOptionsDrawscale200(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("DrawScale") == 200;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnUpdateOptionsDrawscale25(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("DrawScale") == 25;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnUpdateOptionsDrawscale400(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("DrawScale") == 400;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnUpdateOptionsDrawscale50(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("DrawScale") == 50;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnUpdateOptionsDrawscale75(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("DrawScale") == 75;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnUpdateOptionsDrawscaleFittoscreen(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("DrawScale") == 0;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnOptionsRubberbandBoth()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("RubberBand", ITG_RBBoth);
}

void CMainFrame::OnOptionsRubberbandHandles()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("RubberBand", ITG_RBHandles);
}

void CMainFrame::OnOptionsRubberbandItems()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("RubberBand", ITG_RBItems);
}

void CMainFrame::OnOptionsRubberbandNone()
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	pITG->SetNumProperty("RubberBand", ITG_RBNone);
}

void CMainFrame::OnUpdateOptionsRubberbandBoth(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("RubberBand") == ITG_RBBoth;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnUpdateOptionsRubberbandHandles(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("RubberBand") == ITG_RBHandles;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnUpdateOptionsRubberbandItems(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("RubberBand") == ITG_RBItems;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnUpdateOptionsRubberbandNone(CCmdUI* pCmdUI)
{
	CVBControl *pITG = ((CItgDemoView *)GetActiveView())->m_ITGraph;
	int isSet = pITG->GetNumProperty("RubberBand") == ITG_RBNone;
	pCmdUI->SetCheck(isSet ? 1 : 0);	
}

void CMainFrame::OnSpecialRandomsizednodes()
{
	CItgDemoView *pView = (CItgDemoView *)GetActiveView();
	pView->m_bRandomSizedNodes = !pView->m_bRandomSizedNodes;
}

void CMainFrame::OnUpdateSpecialRandomsizednodes(CCmdUI* pCmdUI)
{
	CItgDemoView *pView = (CItgDemoView *)GetActiveView();
	pCmdUI->SetCheck(pView->m_bRandomSizedNodes ? 1 : 0);	
}

void CMainFrame::OnSpecialRandomtree15nodes()
{
	CItgDemoView *pView = (CItgDemoView *)GetActiveView();
	pView->RandomTree(15);
}

void CMainFrame::OnSpecialRandomtree25nodes()
{
	CItgDemoView *pView = (CItgDemoView *)GetActiveView();
	pView->RandomTree(25);
}

void CMainFrame::OnSpecialRandomtree50nodes()
{
	CItgDemoView *pView = (CItgDemoView *)GetActiveView();
	pView->RandomTree(50);
}

void CMainFrame::OnSpecialRandomtree8nodes()
{
	CItgDemoView *pView = (CItgDemoView *)GetActiveView();
	pView->RandomTree(8);
}

void CMainFrame::OnSpecialRandomdirectedgraph15nodes()
{
	CItgDemoView *pView = (CItgDemoView *)GetActiveView();
	pView->RandomDirected(15);
}

void CMainFrame::OnSpecialRandomdirectedgraph25nodes()
{
	CItgDemoView *pView = (CItgDemoView *)GetActiveView();
	pView->RandomDirected(25);
}

void CMainFrame::OnSpecialRandomdirectedgraph50nodes()
{
	CItgDemoView *pView = (CItgDemoView *)GetActiveView();
	pView->RandomDirected(50);
}

void CMainFrame::OnSpecialRandomdirectedgraph8nodes()
{
	CItgDemoView *pView = (CItgDemoView *)GetActiveView();
	pView->RandomDirected(8);
}

void CMainFrame::OnUpdateFilePrintout(CCmdUI* pCmdUI)
{
	CItgDemoView *pView = (CItgDemoView *)GetActiveView();
	if(pView->m_nPrintoutType == 1)
		pCmdUI->SetText("Printout (Graph)");
	else
		pCmdUI->SetText("Printout (Report)");
}

void CMainFrame::OnFilePrintout()
{
	CItgDemoView *pView = (CItgDemoView *)GetActiveView();
	if(pView->m_nPrintoutType == 1)
		pView->m_nPrintoutType = 2; // Print a Report
	else
		pView->m_nPrintoutType = 1; // Print the Graph
}
